--[[
-- BigWigs Strategy Module 
-- Warns the raid when someone is Dazed.
-- OMG I still remember wiping to Gluth because of Dazes.
-- May he live forever!
--]]

------------------------------
--      Are you local?      --
------------------------------

local name = "Zombie Food"
local times = nil
local dazedName, _, dazedIcon = GetSpellInfo(1604)

local L = LibStub("AceLocale-3.0"):NewLocale("Big Wigs: Zombie Food", "enUS", true)
if L then
	L["Zombie Food"] = true
	L["zombiefood"] = true
	L["Optionally broadcast the raid when someone gets Dazed."] = true
	L["broadcast"] = true
	L["Broadcast"] = true
	L["Toggle broadcasting."] = true
	L["On"] = true
	L["on"] = true
	L["Toggles the plugin on and off."] = true
	L["%s has been Dazed!"] = true
end

L = LibStub("AceLocale-3.0"):NewLocale("Big Wigs: Zombie Food", "zhCN")
if L then
	L["Zombie Food"] = "眩晕警告器"
	L["zombiefood"] = "眩晕警告器"
	L["Optionally broadcast the raid when someone gets Dazed."] = "当某玩家眩晕时将会向团队广播。"
	L["broadcast"] = "广播"
	L["Broadcast"] = "广播"
	L["Toggle broadcasting."] = "切换广播。"
	L["On"] = "打开"
	L["on"] = "打开"
	L["Toggles the plugin on and off."] = "是否使用此插件。"

	L["%s has been Dazed!"] = "%s受到了眩晕效果的影响"
end
L = LibStub("AceLocale-3.0"):GetLocale("Big Wigs: Zombie Food")

local mod = BigWigs:NewPlugin(L[name])
if not mod then return end
function mod:GetLocale() return L end

mod.subPanelOptions = {
	key = "Big Wigs: Zombie Food",
	name = L["Zombie Food"],
	options = {
		type = "group",
		name = L["Zombie Food"],
		args = {
			heading = {
				type = "description",
				name = L["Optionally broadcast the raid when someone gets Dazed."],
				order = 1,
				width = "full",
				fontSize = "medium",
			},
			on = {
				type = "toggle",
				name = L["On"],
				desc = L["Toggles the plugin on and off."],
				order = 2,
				width = "full",
				get = function() return mod.db.profile.on end,
				set = function(_, v)
					mod.db.profile.on = v
					if v then
						mod:RegisterEvent("UNIT_AURA")
					else
						mod:UnregisterEvent("UNIT_AURA")
					end
				end,
			},
			broadcast = {
				type = "toggle",
				name = L["Broadcast"],
				desc = L["Toggle broadcasting."],
				order = 3,
				width = "full",
				get = function() return mod.db.profile.broadcast end,
				set = function(_, v) mod.db.profile.broadcast = v end,
			},
		},
	},
}

mod.defaultDB = {
	broadcast = false,
	on = true,
}

function mod:OnPluginEnable()
	if self.db.profile.on then
		self:RegisterEvent("UNIT_AURA")
	end
	times = {}
end

-- XXX should use the combat log etc, but it works I guess
function mod:UNIT_AURA(unit)
	if not unit or not UnitInRaid(unit) then return end
	local i = 1
	local name = UnitDebuff(unit, i)
	while name do
		if name == dazedName then
			local n = UnitName(unit)
			if not times[n] or (times[n] + 5) < GetTime() then
				self:SendMessage("BigWigs_Message", nil, nil, L["%s has been Dazed!"]:format(n), "Urgent", not self.db.profile.broadcast, nil, nil, dazedIcon)
				times[n] = GetTime()
			end
			break
		end
		i = i + 1
		name = UnitDebuff(unit, i)
	end
end

